

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.paysafecard.merchant.Debug;
import com.paysafecard.merchant.Log;
import com.paysafecard.merchant.SOPGClassicMerchantClient;

/**
 * Servlet implementation class index
 */
@WebServlet("/createDisposition")
public class createDisposition extends HttpServlet {
	private static final long serialVersionUID = 1L;
	//Declare a private variable which will later contain the client
	private static SOPGClassicMerchantClient client;
	
	       
	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		/*
		 * This function reads the form entries and saves them in variables.
		 */
		String amount = request.getParameter("amount");
		String mtid = request.getParameter("mtid");
		String currency = request.getParameter("currency");
		String lang = request.getParameter("lang");
		boolean autokorrektur;
		// A boolean (true or false) is set depending on the value of the field in this and the next parameter.  
		if(request.getParameter("autokorrektur") != null && request.getParameter("autokorrektur").equals("on")){
			autokorrektur = true;
		}else{
			autokorrektur = false;
		}
		boolean debug;
		if(request.getParameter("debug") != null && request.getParameter("debug").equals("on")){
			debug = true;
		}else{
			debug = false;
		}
		
		// Initialize SOPG client
		client = new SOPGClassicMerchantClient("test", debug, lang, autokorrektur);
		// Set Merchant access data
		client.merchant("psc_teststeinweber_test", "KKIJSC8GXB75F");
		// Pass values from form to the client
		client.setCustomer(amount, currency, mtid, "50000");
		// Set the URl's
		String baseurl;
		if(request.getServerPort() == 80){
			baseurl = request.getScheme() + "://" + request.getServerName() + request.getContextPath();
		}else{
			baseurl = request.getScheme() + "://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath();
		}
		String allParams = "?amount=" + amount + "&currency=" + currency + "&debug=" + debug + "&lang=" + lang + "&mtid=" + mtid + "&autokorrektur=" + autokorrektur;
		HttpSession session = request.getSession(true);
		session.setAttribute("param_debug", debug);
		session.setAttribute("params_autokorrektur", autokorrektur);
		session.setAttribute("param_lang", lang);
		try {
			client.setUrl(baseurl + "/transSuccess" + allParams, baseurl + "/transError", baseurl + "transPN?currency=" + currency + "&amount=" + amount);
			//Get URL to confirm payment transaction and save to variable confirmURL
			String confirmURL = client.createDisposition();
			// Save log entries and debug in the session
			session.setAttribute("debug", Debug.getDebug());
			//Clear debug
			Debug.clear();
			session.setAttribute("error_log", Log.getLog("error"));
			session.setAttribute("info_log", Log.getInfoLog());
			//Check whether the confirmation URL is not empty, if so: redirect
			if(confirmURL != "false"){
				response.sendRedirect(confirmURL);
			}else{
				response.sendRedirect(baseurl + "/transError");
			}
		} catch (Exception e) {
			// Do nothing
		}
	}

}
